<template>
	<div
		class="mx-auto flex-col md:rounded bg-white w-full md:w-570 lg:w-690 px-4 py-6 md:px-6 lg:px-10 lg:py-10 mb-2 md:mt-1 lg:mt-2"
	>
		<div v-if="stepsCompleted == 1" class="flex flex-col md:flex-row justify-between mb-6 md:items-center">
			<MkStepProgress
				:step-title="stepTitle"
				:step-number="stepNumber"
				:class-active="stepsCompleted == 1 ? 'active' : ''"
			/>
			<div class="font-primary-font-light mt-10 md:mt-0">
				<span v-if="stepTitle == 'Device details'"> Have an account? </span>
				<a
					tabindex="0"
					role="button"
					class="font-primary-font-bold ml-1 mk-link"
					@keydown.enter="changeRegDevice($event)"
					@click="changeRegDevice($event)"
					>{{ stepTitle == 'Device details' ? 'Sign in' : 'Create account' }}</a
				>
			</div>
		</div>
		<div v-if="stepsCompleted != 1">
			<div class="flex flex-row justify-between mb-6">
				<div class="flex flex-row items-center">
					<MkSuccessIcon />
					<p class="font-secondary-font-regular text-xl md:text-2xl leading-6 md:leading-7 lg:leading-8 pl-4 lg:pl-6">
						<span v-if="title != 'Device details'">Device details</span>
						<span v-else>Sign in</span>
					</p>
				</div>
				<div>
					<p v-if="AUTHENTICATED" class="font-primary-font-bold mk-link" tabindex="0" role="button" @keydown.enter="signOut()" @click="signOut()">
						Sign out
					</p>
					<p
						class="font-primary-font-bold mk-link"
						tabindex="0"
						role="button"
						@keydown.enter="editData()"
						@click="editData()"
					>
						Edit
					</p>
				</div>
			</div>
			<div v-if="regDevice" class="md:ml-12 lg:ml-16 font-primary-font-light text-base leading-6">
				<p class="pl-1">{{ value.serialNumber }}</p>
				<p class="pt-4 pl-1">{{ value.purchaseDate }}</p>
			</div>
			<div v-else class="md:ml-12 lg:ml-16 font-primary-font-light text-base leading-6">
				<p class="pl-1">
					{{ (AUTHENTICATED && CUSTOMER_EMAIL) || value.email }}
				</p>
				<p class="pt-4 pl-1">••••••••</p>
			</div>
		</div>
		<div v-if="stepsCompleted == 1">
			<ValidationObserver ref="device_details_validation_observer">
				<div v-if="regDevice">
					<div class="relative">
						<MkInput
							name="Serial number"
							rules="required"
							class=""
							variant="outline"
							label="Serial number"
							:value="value.serialNumber"
							@input="updateForm('serialNumber', $event), checkSerialNumber()"
						/>
						<p
							v-show="(value.serialNumber != '' && errorMsg) || DEVICE_ERROR_MSG"
							class="text-error-20 text-sm mt-1"
							role="alert"
							aria-live="polite"
						>
							{{ errorMsg || DEVICE_ERROR_MSG }}
						</p>
						<div
							class="inline-block absolute right-0 top-0 transform translate-y-5 group p-0.5 mk-tooltip"
							role="tooltip"
							tabindex="0"
						>
							<span class="icon-notification" aria-label="Features auto-refills tooltip"></span>
							<MkCartTooltip class="hidden group-hover:block" :rotate-left="true" :icon-position="toolTipPosition">
								<template #tooltipRightValue>
									<p>Your 19-digit serial number can be found:</p>
									<p>. In the app (Settings > Technical info)</p>
									<p>. On the box’s shipping label</p>
									<p>. On the bottom of the device</p>
									<p
										>.
										<a class="text-white" target="_blank" :href="`https://help.molekule.com/hc/en-us/requests/new`"
											>Still need help?</a
										></p
									>
								</template>
							</MkCartTooltip>
						</div>
					</div>
					<div class="relative mt-6">
						<MkInput
							:name="estimatedDate"
							rules="required|date"
							class="mb-4"
							variant="outline"
							:label="estimatedDate"
							:value="value.purchaseDate"
							@input="updateForm('purchaseDate', $event)"
						/>
						<div class="inline-block absolute right-0 top-0 transform translate-y-5 group ml-2 mk-tooltip">
							<span class="font-primary-font-light text-base leading-6 pointer-events-none">MM/DD/YYYY</span>
						</div>
					</div>
					<div class="flex justify-center items-center mt-10">
						<MkPrimaryButton
							btn-class="min-w-150 h-10 font-primary-font-regular text-base leading-6"
							:loading="loading"
							:disabled="!value['serialNumber'] || !value['purchaseDate']"
							button-title="Next"
							font-size="text-xl"
							@click="completedstep('Device details')"
						/>
					</div>
				</div>
				<div v-if="!regDevice">
					<MkErrorMessage v-if="warning" role="alert" class="my-4" />
					<MkInput
						name="Email"
						rules="required|email"
						:value="value['email']"
						class="mb-4"
						variant="outline"
						label="Email"
						@input="updateForm('email', $event)"
					/>
					<MkInput
						name="Password"
						rules="required"
						:value="value['password']"
						class="mb-4"
						variant="outline"
						label="Password"
						:type="'password'"
						@input="updateForm('password', $event)"
					/>

					<div class="flex justify-center items-center mt-10">
						<MkPrimaryButton
							btn-class="min-w-150 py-2 h-10"
							:loading="loading"
							:disabled="!value['email'] || !value['password']"
							button-title="Next"
							font-size="text-xl"
							@click="completedstep('Sign In')"
						/>
					</div>
					<div class="mt-8 md:mt-6 text-center">
						<a
							href="/D2C/login/passwordReset"
							class="font-primary-font-bold md:font-primary-font-light lg:font-primary-font-bold my-4 mk-link"
							>I forgot my password</a
						>
					</div>
				</div>
			</ValidationObserver>
		</div>
	</div>
</template>
<script>
import { ValidationObserver } from 'vee-validate';
import { mapState } from 'vuex';
import MkStepProgress from '~/components/D2C/atoms/MkStepProgress.vue';
import MkInput from '~/components/D2C/atoms/MkInput.vue';
import MkPrimaryButton from '~/components/D2C/atoms/MkPrimaryButton.vue';
import MkCartTooltip from '~/components/D2C/atoms/MkCartTooltip.vue';
import MkSuccessIcon from '~/components/D2C/atoms/MkSuccessIcon.vue';
import MkErrorMessage from '~/components/D2C/atoms/MkErrorMessage.vue';
export default {
	name: 'MkDeviceDetails',
	components: {
		MkStepProgress,
		MkInput,
		MkPrimaryButton,
		MkCartTooltip,
		MkSuccessIcon,
		ValidationObserver,
		MkErrorMessage,
	},
	props: {
		stepsCompleted: {
			type: Number,
			default: 1,
		},
		value: {
			type: Object,
			default: () => {},
		},
		estimatedDate: {
			type: String,
			default: 'Est. purchase date',
		},
		editing: {
			type: Boolean,
			default: true,
		},
		title: {
			type: String,
			default: 'Create account',
		},
		gift: {
			type: Boolean,
			default: false,
		},
	},
	data() {
		return {
			warning: false,
			loading: false,
			stepNumber: 1,
			emailExists: false,
			toolTipPosition: {},
			showRegister: true,
			regCustomer: false,
			submitProcess: false,
			loginCount: 0,
			formData: {},
			regDevice: true,
			errorMsg: '',
			validSerial: false,
		};
	},
	computed: {
		...mapState('USER_STORE', ['DEVICE', 'CUSTOMER_EMAIL', 'AUTHENTICATED', 'DEVICE_ERROR_MSG', 'CUSTOMERID']),
		stepTitle() {
			if (!this.regDevice) {
				return 'Sign in';
			} else {
				return 'Device details';
			}
		},
	},
	watch: {
		title: {
			deep: true,
			handler() {
				this.handelShow();
			},
		},
	},
	methods: {
		async signOut() {
			await this.$store.dispatch('USER_STORE/SIGN_OUT', { path: this.$route.path });
			this.editData()
		},
		editData() {
			if (this.stepTitle === 'Device details') {
				this.regDevice = true;
			} else {
				this.regDevice = false;
			}
			this.$emit('edit-device');
		},
		async completedstep(flag) {
			try {
				const isValidForm = await this.$refs.device_details_validation_observer.validate();
				if (isValidForm) {
					this.loading = true;
					if (flag === 'Device details' && this.validSerial) {
						this.$emit('completedstep', this.value);
					} else {
						const payload = {
							email: this.value.email,
							password: this.value.password,
						};
						const isSuccessfull = await this.$store.dispatch('USER_STORE/SIGN_IN', payload);
						if (isSuccessfull === 'pass') {
							this.$store.commit('USER_STORE/RESET_COG_FORMS');
							this.emailExists = true;
							this.$emit('completedstep', this.value);
							if (this.CART && this.CART.anonymousId) {
								await this.$store.dispatch('CART_STORE/MERGE_CART');
							}
							this.warning = false;
						} else if (['login fails', 'locked', 'invalid credentials'].includes(isSuccessfull)) {
							this.loginCount++;
							if (this.loginCount === 4) {
								await this.$store.dispatch('USER_STORE/CHECK_USER_EXISTS', this.formData);
							}
							if (isSuccessfull === 'locked') {
								this.$store.commit('USER_STORE/SET_SIGN_IN_ERROR', {
									message:
										'There have been too many failed login attempts. To access your account, reset your password.',
								});
								this.loginCount = 0;
								this.formData = {};
								this.$refs.device_details_validation_observer.reset();
							}
							if (isSuccessfull === 'invalid credentials') {
								this.$store.commit('USER_STORE/SET_SIGN_IN_ERROR', {
									message: 'Incorrect username or password.',
								});
								this.formData = {};
								this.$refs.device_details_validation_observer.reset();
							}
							this.warning = true;
						}
					}
				}
				this.loading = false;
			} catch (error) {
				this.loading = false;
			}
		},
		updateForm(fieldName, value) {
			this.formData[fieldName] = value;
			this.$set(this.value, fieldName, value);
			this.$emit('input', this.value);
		},
		async checkSerialNumber() {
			try {
				const id = this.formData.serialNumber;
				this.$store.commit('USER_STORE/SET_DEVICE_ERROR_MSG', '');
				const res = await this.$repositories.user.checkDeviceSerial(id);
				if (res.status === 200 && res.data) {
					const { error, output } = res.data;
					if (error) {
						this.errorMsg = error.message;
						this.validSerial = false;
					} else if (output && output.status && output.status === 'Failed') {
						this.errorMsg = output.message;
						this.validSerial = false;
					} else if (output && output.status && output.status === 'Success') {
						this.errorMsg = '';
						this.validSerial = true;
					}
				}
			} catch (error) {}
		},
		changeRegDevice(e) {
			e.preventDefault();
			this.regDevice = !this.regDevice;
			this.$emit('change-view', this.regDevice);
		},
		handelShow() {
			if (this.title === 'Device details') {
				this.regDevice = false;
			} else {
				this.regDevice = true;
			}
		},
	},
};
</script>
